/* tripper12_test(Release)
 * cz.Trip..PlX
 * SHA-1ASYpN
 * http://www.ipa.go.jp/security/rfc/RFC3174JA.html */

/*
	}`XbhKɉ by 
*/

/*
	p^[}b`Ȃǉǁ@By cz.Trip..PlX
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <time.h>
#include <windows.h>

#pragma intrinsic(_lrotl, memcpy, memset)

#define TIME_COUNT /* x\ */
#undef DEBUG_PRINT /* fobN\ */

#define MAX_THREADS 4	/* őXbh */

typedef unsigned long int DWORD;
typedef unsigned char BYTE;

char* set_find();
int trip_str(const BYTE[], const char*, const int, const int);
void sha1trip(const BYTE[], BYTE[]);

const char b64t[] = {
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 
	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 
	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 
	'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '/'
};

static long volatile trip_count;
#ifdef TIME_COUNT
clock_t start_time;
#endif

/*
	XorShiftŋ[
	͕ʂɑvȂ̂ŁAMT̕
*/
typedef struct {
	DWORD x, y, z, w, temp;
} rand_params;

#define rand_init(params, seed) \
	((params).x=(seed)/*123456789UL*/, (params).y=362436069UL, \
	(params).z=521288629UL, (params).w=88675123UL)

#define rand_get(params) \
	((params).temp=(params).x^((params).x<<11), \
	(params).x=(params).y, (params).y=(params).z, (params).z=(params).w, \
	(params).w^=((params).w>>19)^(params).temp^((params).temp>>8))

typedef struct {
	const char *pattern;
	DWORD seed;
	FILE *fp;
	CRITICAL_SECTION *lock;
	int primary;
	int m;
	int n;
} thread_params;

void thread(void *data)
{
	thread_params *params=(thread_params*)data;
	const char *pattern=params->pattern;
	BYTE c[64] = {0}, t[13] = {0};
	rand_params random;
	int i, j, m = params->m, n = params->n;
	int ctrip = 0;

	rand_init(random, params->seed);

	c[15] = 128;
	c[60] = 96;
	for (i = 0; i < 12; i++)
		c[i] = (BYTE)(rand_get(random) % 94 + 33);
	i = (BYTE)(rand_get(random) % 92);
	c[3] = i + ((i < 2) ? 33 : 35);

	for (;;) {
		sha1trip(c, t);
		if (trip_str(t, pattern, m, n)) {
			char a[13];

			for (i = 0; i < 3; i++)
				for (j = 0; j < 4; j++)
					a[i*4+j] = c[i*4+3-j];
			a[12] = '\0';

			EnterCriticalSection(params->lock);
			printf("%s #%s\n", t, a);
			fprintf(params->fp, "%s #%s\n", t, a);
			fflush(params->fp);
			LeaveCriticalSection(params->lock);

			for (i = 0; i < 12; i++)
				c[i] = (BYTE)(rand_get(random) % 94 + 33);
			i = (BYTE)(rand_get(random) % 92);
			c[3] = i + ((i < 2) ? 33 : 35);
		} else {
			c[11]++;
			for (i = 11; i > 0; i--) {
				if (c[i] == 127) {
					c[i] = 33;
					c[i - 1]++;
				} else break;
			}
			if (c[3] == 35) c[3] = 37;
			if (c[0] == 127) memset(c, 33, 12);
		}

#ifdef TIME_COUNT
		ctrip++;
		if (!(ctrip&0xFF)) {
			EnterCriticalSection(params->lock);
			trip_count += ctrip;
			if (params->primary) {
				clock_t ctime = clock();
				if (ctime - start_time >= CLOCKS_PER_SEC * 10) {
					long rate = (long)((__int64)trip_count * CLOCKS_PER_SEC / (ctime - start_time));
					printf("%ld.%03ldktrips/s\n", rate / 1000, rate % 1000);
					start_time = ctime;
					trip_count = 0;
				}
			}
			LeaveCriticalSection(params->lock);
			ctrip = 0;
		}
#endif
	}

	_endthread();
}

int main() {
	char *p, **pp;
	FILE *fp;
	int num_threads;
	CRITICAL_SECTION output_lock;
	DWORD seed;
	thread_params params[MAX_THREADS];
	DWORD process_affinity, system_affinity;
	int i, j, m, n, l[12];

	fp = fopen("log.txt", "a");
	if (!fp) {
		fprintf(stderr,"log.txtJ\n");
		system("pause");
		return 0;
	}
	p = set_find();
	if (!p) {
		system("pause");
		return 0;
	}
	pp = (char**)p;
	for (i = 0; i < 12; i++) {
		for (j = 0; j < 77; j++) {
			if (*(pp + i * 77 + j)) break;
		}
		l[i] = (j == 77) ? 0 : 1;
	}
	for (m = 0; m < 12; m++) {
		if (l[m]) break;
	}
	for (n = 12; n > 0; n--) {
		if (l[n - 1]) break;
	}

	SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);

	num_threads = 1;
	if (GetProcessAffinityMask(GetCurrentProcess(), &process_affinity, &system_affinity)) {
		for (; num_threads < MAX_THREADS; num_threads++) {
			if (!(process_affinity & (1UL << num_threads)))
				break;
		}
	}

	InitializeCriticalSection(&output_lock);
	seed = GetTickCount() ^ (DWORD)time(NULL);
	for (i = 0; i < num_threads; i++) {
		params[i].pattern = p;
		params[i].seed = seed + i;
		params[i].fp = fp;
		params[i].lock = &output_lock;
		params[i].primary = i == 0;
		params[i].m = m;
		params[i].n = n;
	}

	printf("Xbh%dŎn߂\n", num_threads);
#ifdef TIME_COUNT
	start_time = clock();
#endif

	for (i = 1; i < num_threads; i++)
		_beginthread(thread, 0, &params[i]);

	thread(&params[0]);

	// ǂsȂ
	free(p);
	fclose(fp);

	return 0;
}

char* set_find() {
	char *p, *tp, **pp, **tpp, tmp[12][64] = {0}, ncm[12]={0}, ncn[12]={0}, ckt[13] = {0};
	int c, i, j, m = 0, n = 0, u = 0, f = 0, t = 0, e = 0, k = 0, tic[12][64] = {0};
	FILE *fp;
	size_t s = sizeof(char*) * 12 * 77;
	fp = fopen("target.txt", "r");
	if (!fp) {
		printf("target.txtȂJ\n");
		return 0;
	}
	printf("p^[WJŁc\n");
	while (k < 3) {
		c = fgetc(fp);
		if (c == EOF){
			c = '\n';
			if (!k) fseek(fp, 0, SEEK_SET);
			k++;
		}
		if (c == ';' || c == '#') {
			f = 4;
		} else if (c == '$') {
			e = 1;
			f = 4;
		} else if (c == '\n') {
			if (f == 1 || f == 3) m++;
			else if (f == 2) {
				for (i = u; i < 64; i++) {
					tmp[m][i] = 1;
				}
				m++;
			}
			for (i = 0; i < m; i++) {
				if (!ncm[i]) {
					for (j = 0; j < 64; j++) {
						if (tmp[i][j]) ncm[i]++;
					}
					if (ncm[i] == 0) ncm[i] = 64;
				}
			}
			if (k < 2 && m) {
				u = 0;
				for (i = 0; i < m; i++) {
					if (ncm[i] == 64) u++;
					else break;
				}
				if (t) {
					for (j = 0; j < 64; j++) {
						if (tmp[u][j]) tic[u][j]++;
					}
				} else if (e) {
					for (j = 0; j < 64; j++) {
						if (tmp[u][j]) tic[12 - m + u][j]++;
					}
				} else {
					for (i = 0; i + m <= 12; i++) {
						for (j = 0; j < 64; j++) {
							if (tmp[u][j]) tic[i + u][j]++;
						}
					}
				}
				for (i = m - 1; i <= 0; i--) {
					if (ncm[i] == 64) u++;
					else break;
				}
				s += (m - u) * 77;
			}
			if (k == 1) {
				u = 0;
				for (i = 0; i < 12; i++) {
					for (j = 0; j < 64; j++) {
						if (tic[i][j]) u += tic[i][j] + 1;
					}
				}
				s += sizeof(char*) * u;
				p = (char*)malloc(s);
				memset(p, 0, s);
				if (!p) {
					printf("^[Qbgێp̃mۂł\n");
					fclose(fp);
					return 0;
				}
				printf("%doCgmۂ\n", s);
				pp = (char**)p;
				tpp = pp + 12 * 77;
				tp = (char*)(tpp + u);
#ifdef DEBUG_PRINT
				printf("tic\n");
				for (i = 0; i < 64; i++) {
					putchar(b64t[i]);
				}
				putchar('\n');
				for (i = 0; i < 12; i++) {
					for (j = 0; j < 64; j++) {
						printf("%d", tic[i][j]);
					}
					printf("\n");
				}
				printf("\n");
#endif
				for (i = 0; i < 12; i++) {
					for (j = 0; j < 64; j++) {
						u = tic[i][j];
						if (u) {
							*(pp + i * 77 + b64t[j] - 0x2e) = (char*)tpp;
							tpp += u + 1;
						}
					}
				}
				k++;
			} else if (k > 1) {
				for (u = 0; u < m; u++) {
					if (ncm[u] != 64) break;
				}
				n = m;
				while (n-- >= 0) {
					if (ncm[n] != 64) break;
				}
				if (n >= 0) {
#ifdef DEBUG_PRINT
					printf("length = %d\n   ", m);
					for (i = 0; i < 64; i++) {
						putchar(b64t[i]);
					}
					putchar('\n');
					for (i = 0; i < 12; i++) {
						printf("%2d ", ncm[i]);
						for (j = 0; j < 64; j++) {
							printf("%d", tmp[i][j]);
						}
						printf("\n");
					}
					printf("\n");
#endif
					if (t) {
						for (j = 0; j < 64; j++) {
							if (tmp[u][j]) {
								tpp = (char**)*(pp + u * 77 + b64t[j] - 0x2e);
								while (*tpp) tpp++;
								*tpp = tp;
							}
						}
					} else if (e) {
						i = 12 - m;
						for (j = 0; j < 64; j++) {
							if (tmp[u][j]) {
								tpp = (char**)*(pp + i * 77 + b64t[j] - 0x2e);
								while (*tpp) tpp++;
								*tpp = tp;
							}
						}
					} else {
						for (i = u; i - u + m <= 12; i++) {
							for (j = 0; j < 64; j++) {
								if (tmp[u][j]) {
									tpp = (char**)*(pp + i * 77 + b64t[j] - 0x2e);
									while (*tpp) tpp++;
									*tpp = tp;
								}
							}
						}
					}
					for (i = u; i < n; i++) {
						if (ncm[i] == 64) {
							for (j = 0; j < 77; j++) {
								tp[j] = 1;
							}
						} else {
							for (j = 0; j < 64; j++) {
								if (tmp[i][j]) {
									tp[b64t[j] - 0x2e] = 1;
								}
							}
						}
						tp += 77;
					}
					for (j = 0; j < 64; j++) {
						if (tmp[i][j]) {
							tp[b64t[j] - 0x2e] = 2;
						}
					}
					tp += 77;
				}
			}
			m = 0;
			f = 0;
			t = 0;
			e = 0;
			for (i = 0; i < 12; i++) {
				for (j = 0; j < 64; j++) {
					tmp[i][j] = 0;
				}
				ncm[i] = 0;
				ckt[i] = 0;
			}
			ckt[12] = 0;
		} else if(m == 12 && f != 4){
			f = 4;
		} else {
			switch (f) {
				case 0:
					if (m == 0 && c == '^') {
						t = 1;
					} else if (c == '[') {
						u = 0;
						f = 1;
					} else {
						for (i = 0; i < 64; i++) {
							if (c == b64t[i]) break;
						}
						if (i == 64) {
							ncm[m] = 64;
						} else {
							ncm[m] = 1;
							ncn[m] = c;
							tmp[m][i] = 1;
						}
						m++;
					}
					break;
				case 1:
					if (c == ']') {
						m++;
						f = 0;
					} else if (c == '-') {
						f = 2;
					} else {
						for (i = 0; i < 64; i++) {
							if (c == b64t[i]) break;
						}
						if (i == 64) {
							ncm[m] = 64;
							f = 3;
						} else {
							u = i;
							tmp[m][i] = 1;
						}
					}
					break;
				case 2:
					if (c == ']') {
						for (i = u; i < 64; i++) {
							tmp[m][i] = 1;
						}
						m++;
						f = 0;
					} else {
						for (i = 0; i < 64; i++) {
							if (c == b64t[i]) break;
						}
						if (i == 64) {
							ncm[m] = 64;
							f = 3;
							break;
						}
						if (u < i) {
							j = u;
						} else {
							j = i;
							i = u;
						}
						while (j <= i) {
							tmp[m][j] = 1;
							j++;
						}
						f = 1;
					}
					u = 0;
					break;
				case 3:
					if (c == ']') {
						m++;
						f = 0;
					}
					break;
			}
		}
	}
	*tp = 0;
#ifdef DEBUG_PRINT
	printf("WJF%doCg\n", u = (int)(tp - p));
	k = 0;
	for (i = 0; i < 12; i++) {
		for (j = 0; j < 64; j++) {
			if (tic[i][j]) k += tic[i][j] + 1;
		}
	}
	tp = p + sizeof(char*) * (12 * 77 + k);
	tpp = (char**)p;
	printf("         ");
	for (i = 0; i < 77; i++) {
		printf("%c", i + 0x2e);
	}
	printf("\n");
	k = 0;
	for (i = 0; i < 12; i++) {
		printf("%p:", tpp);
		for (j = 0; j < 77; j++) {
			if (tpp[j]) printf("1");
			else printf("0");
		}
		printf("\n");
		tpp += 77;
	}
	printf("\n");
	tpp = (char**)p;
	for (i = 0; i < 12; i++) {
		for (j = 0; j < 77; j++) {
			if (tpp[j]) {
				printf("%p:%p\n", tpp + j, tpp[j]);
			}
		}
		tpp += 77;
	}
	printf("\n");
	while (tp != (char*)tpp) {
		printf("%p:%p\n", tpp, *tpp);
		tpp++;
	}
	printf("\n");
	printf("         ");
	for (i = 0; i < 77; i++) {
		printf("%c", i + 0x2e);
	}
	printf("\n");
	while (tp < p + u) {
		printf("%p:", tp);
		for (i = 0; i < 77; i++) printf("%d", tp[i]);
		printf("\n");
		tp += 77;
	}
	printf("%p:\n", tp);
	system("pause");
#endif
	fclose(fp);
	return p;
}

int trip_str(const BYTE trip[], const char *ptn, const int m, const int n) {
	int i, j, t;
	char **tpp, *tp;
	for (i = m; i < n; i++) {
		tpp = ((char**)ptn + i * 77 + trip[i] - 0x2e);
		if (*tpp) {
			tpp = (char**)*tpp;
			while (*tpp) {
				tp = *tpp;
				j = i;
				for (;;) {
					t = *(tp + trip[j] - 0x2e);
					if (t == 0) break;
					else if (t == 2) return 1;
					tp += 77;
					j++;
				}
				tpp++;
			}
		}
	}
	return 0;
}

#define f00(B,C,D) ((B & C) | ((~B) & D))
#define f20(B,C,D) (B ^ C ^ D)
#define f40(B,C,D) ((B & C) | (B & D) | (C & D))
#define f60(B,C,D) (B ^ C ^ D)
//#define SHA1CircularShift(bits,word) (((word) << (bits)) | ((word) >> (32-(bits))))
#define SHA1CircularShift(bits,word) _lrotl(word, bits)
void sha1trip(const BYTE block[], BYTE out[]) {
	int t;
	DWORD A, B, C, D, E;
	DWORD K0 = 0x5A827999;
	DWORD K1 = 0x6ED9EBA1;
	DWORD K2 = 0x8F1BBCDC;
	DWORD K3 = 0xCA62C1D6;
	DWORD H0 = 0x67452301;
	DWORD H1 = 0xEFCDAB89;
	DWORD H2 = 0x98BADCFE;
	DWORD H3 = 0x10325476;
	DWORD H4 = 0xC3D2E1F0;
	DWORD W[80];
	DWORD TEMP;
	memcpy(W, block, 64);
	for (t = 16; t < 80; t++) {
		W[t] = SHA1CircularShift(1, W[t-3] ^ W[t-8] ^ W[t-14] ^ W[t-16]);
	}
	A = H0;
	B = H1;
	C = H2;
	D = H3;
	E = H4;
	for (t = 0; t < 20; t++) {
		TEMP = SHA1CircularShift(5, A) + f00(B, C, D) + E + W[t] + K0;
		E = D;
		D = C;
		C = SHA1CircularShift(30, B);
		B = A;
		A = TEMP;
	}
	for (t = 20; t < 40; t++) {
		TEMP = SHA1CircularShift(5, A) + f20(B, C, D) + E + W[t] + K1;
		E = D;
		D = C;
		C = SHA1CircularShift(30, B);
		B = A;
		A = TEMP;
	}
	for (t = 40; t < 60; t++) {
		TEMP = SHA1CircularShift(5, A) + f40(B, C, D) + E + W[t] + K2;
		E = D;
		D = C;
		C = SHA1CircularShift(30, B);
		B = A;
		A = TEMP;
	}
	for (t = 60; t < 80; t++) {
		TEMP = SHA1CircularShift(5, A) + f60(B, C, D) + E + W[t] + K3;
		E = D;
		D = C;
		C = SHA1CircularShift(30, B);
		B = A;
		A = TEMP;
	}

	H0 += A;
	H1 += B;
	H2 += C;
	out[0] = b64t[H0>>26];
	out[1] = b64t[H0>>20&63];
	out[2] = b64t[H0>>14&63];
	out[3] = b64t[H0>>8&63];
	out[4] = b64t[H0>>2&63];
	out[5] = b64t[(H0<<4|H1>>28)&63];
	out[6] = b64t[H1>>22&63];
	out[7] = b64t[H1>>16&63];
	out[8] = b64t[H1>>10&63];
	out[9] = b64t[H1>>4&63];
	out[10] = b64t[(H1<<2|H2>>30)&63];
	out[11] = b64t[H2>>24&63];
	return;
}
